package org.dbxml.examples;

/*
 * dbXML Core - Example Code
 *
 * Copyright (c) 1999-2001 The dbXML Group
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to 
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or 
 * sell copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 *    The above copyright notice and this permission notice shall be included 
 *       in all copies of substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
 * IN THE SOFTWARE.
 *
 * $Id: XPathQueryXMLObject.java,v 1.1 2001/05/11 10:04:15 kstaken Exp $
 */

import org.dbxml.core.*;
import org.dbxml.core.objects.*;
import org.dbxml.xml.dom.*;

import org.w3c.dom.*;

import org.apache.xpath.*;

/**
 * Example XMLObject to perform an XPath query against a single document. The
 * result NodeList is returned in a document with a "result" element as the root
 */
public class XPathQueryXMLObject extends SimpleXMLObject {
   public static final String [] PARAMS_query = {"xpath", "id"};   
   public static final String [] DEFAULTS_query = {"/", ""};
   
   public Document query(String xpath, String id) throws Exception {      
      Collection col = getCollection();
      Document target = col.getDocument(id);
      
      NodeList result = XPathAPI.selectNodeList(target, xpath);
      
      // Turn the NodeList into a document.
      Document doc = new DocumentImpl();
      
      Element root = doc.createElement("result");
      doc.appendChild(root);   
      int i = 0;      
      while ( (result != null) && (i < result.getLength()) ) {            
         root.appendChild(doc.importNode(result.item(i), true));
         i++;                     
      }
      
      return doc;
   }
}
